diff --git a/gcc/gimple-ssa-warn-restrict.c b/gcc/gimple-ssa-warn-restrict.c
index 01503d6..eb4e344 100644
--- a/gcc/gimple-ssa-warn-restrict.c
+++ b/gcc/gimple-ssa-warn-restrict.c
@@ -1618,13 +1618,15 @@ maybe_diag_offset_bounds (location_t loc, gimple *call, tree func, int strict,
       if (DECL_P (ref.base)
 	  && TREE_CODE (type = TREE_TYPE (ref.base)) == ARRAY_TYPE)
 	{
-	  if (warning_at (loc, OPT_Warray_bounds,
-			  "%G%qD pointer overflow between offset %s "
-			  "and size %s accessing array %qD with type %qT",
-			  call, func, rangestr[0], rangestr[1], ref.base, type))
+	  diagnostic_group d;
+	  if (d.warning_at (loc, OPT_Warray_bounds,
+			    "%G%qD pointer overflow between offset %s "
+			    "and size %s accessing array %qD with type %qT",
+			    call, func, rangestr[0], rangestr[1], ref.base,
+			    type))
 	    {
-	      inform (DECL_SOURCE_LOCATION (ref.base),
-		      "array %qD declared here", ref.base);
+	      d.inform (DECL_SOURCE_LOCATION (ref.base),
+			"array %qD declared here", ref.base);
 	      warned = true;
 	    }
 	  else
@@ -1650,27 +1652,29 @@ maybe_diag_offset_bounds (location_t loc, gimple *call, tree func, int strict,
 
       if (DECL_P (ref.base))
 	{
+	  diagnostic_group d;
 	  if ((ref.basesize < maxobjsize
-	       && warning_at (loc, OPT_Warray_bounds,
-			      form
-			      ? G_("%G%qD forming offset %s is out of "
-				   "the bounds [0, %wu] of object %qD with "
-				   "type %qT")
-			      : G_("%G%qD offset %s is out of the bounds "
-				   "[0, %wu] of object %qD with type %qT"),
-			      call, func, rangestr[0], ref.basesize.to_uhwi (),
-			      ref.base, TREE_TYPE (ref.base)))
-	      || warning_at (loc, OPT_Warray_bounds,
-			     form
-			     ? G_("%G%qD forming offset %s is out of "
-				  "the bounds of object %qD with type %qT")
-			     : G_("%G%qD offset %s is out of the bounds "
-				  "of object %qD with type %qT"),
-			     call, func, rangestr[0],
-			     ref.base, TREE_TYPE (ref.base)))
+	       && d.warning_at (loc, OPT_Warray_bounds,
+				form
+				? G_("%G%qD forming offset %s is out of "
+				     "the bounds [0, %wu] of object %qD with "
+				     "type %qT")
+				: G_("%G%qD offset %s is out of the bounds "
+				     "[0, %wu] of object %qD with type %qT"),
+				call, func, rangestr[0],
+				ref.basesize.to_uhwi (),
+				ref.base, TREE_TYPE (ref.base)))
+	      || d.warning_at (loc, OPT_Warray_bounds,
+			       form
+			       ? G_("%G%qD forming offset %s is out of "
+				    "the bounds of object %qD with type %qT")
+			       : G_("%G%qD offset %s is out of the bounds "
+				    "of object %qD with type %qT"),
+			       call, func, rangestr[0],
+			       ref.base, TREE_TYPE (ref.base)))
 	    {
-	      inform (DECL_SOURCE_LOCATION (ref.base),
-		      "%qD declared here", ref.base);
+	      d.inform (DECL_SOURCE_LOCATION (ref.base),
+			"%qD declared here", ref.base);
 	      warned = true;
 	    }
 	}
diff --git a/gcc/gimplify.c b/gcc/gimplify.c
index 4a109ae..155155c 100644
--- a/gcc/gimplify.c
+++ b/gcc/gimplify.c
@@ -2173,23 +2173,24 @@ warn_implicit_fallthrough_r (gimple_stmt_iterator *gsi_p, bool *handled_ops_p,
 	  {
 	    struct label_entry *l;
 	    bool warned_p = false;
+	    diagnostic_group d;
 	    if (!should_warn_for_implicit_fallthrough (gsi_p, label))
 	      /* Quiet.  */;
 	    else if (gimple_code (prev) == GIMPLE_LABEL
 		     && (label = gimple_label_label (as_a <glabel *> (prev)))
 		     && (l = find_label_entry (&labels, label)))
-	      warned_p = warning_at (l->loc, OPT_Wimplicit_fallthrough_,
-				     "this statement may fall through");
+	      warned_p = d.warning_at (l->loc, OPT_Wimplicit_fallthrough_,
+				       "this statement may fall through");
 	    else if (!gimple_call_internal_p (prev, IFN_FALLTHROUGH)
 		     /* Try to be clever and don't warn when the statement
 			can't actually fall through.  */
 		     && gimple_stmt_may_fallthru (prev)
 		     && gimple_has_location (prev))
-	      warned_p = warning_at (gimple_location (prev),
-				     OPT_Wimplicit_fallthrough_,
-				     "this statement may fall through");
+	      warned_p = d.warning_at (gimple_location (prev),
+				       OPT_Wimplicit_fallthrough_,
+				       "this statement may fall through");
 	    if (warned_p)
-	      inform (gimple_location (next), "here");
+	      d.inform (gimple_location (next), "here");
 
 	    /* Mark this label as processed so as to prevent multiple
 	       warnings in nested switches.  */
@@ -13079,20 +13080,22 @@ gimplify_va_arg_expr (tree *expr_p, gimple_seq *pre_p,
       /* Unfortunately, this is merely undefined, rather than a constraint
 	 violation, so we cannot make this an error.  If this call is never
 	 executed, the program is still strictly conforming.  */
-      warned = warning_at (xloc, 0,
-			   "%qT is promoted to %qT when passed through %<...%>",
-			   type, promoted_type);
+      diagnostic_group d;
+      warned
+	= d.warning_at (xloc, 0,
+			"%qT is promoted to %qT when passed through %<...%>",
+			type, promoted_type);
       if (!gave_help && warned)
 	{
 	  gave_help = true;
-	  inform (xloc, "(so you should pass %qT not %qT to %<va_arg%>)",
-		  promoted_type, type);
+	  d.inform (xloc, "(so you should pass %qT not %qT to %<va_arg%>)",
+		    promoted_type, type);
 	}
 
       /* We can, however, treat "undefined" any way we please.
 	 Call abort to encourage the user to fix the program.  */
       if (warned)
-	inform (xloc, "if this code is reached, the program will abort");
+	d.inform (xloc, "if this code is reached, the program will abort");
       /* Before the abort, allow the evaluation of the va_list
 	 expression to exit or longjmp.  */
       gimplify_and_add (valist, pre_p);
diff --git a/gcc/hsa-gen.c b/gcc/hsa-gen.c
index 173707d..095eab3 100644
--- a/gcc/hsa-gen.c
+++ b/gcc/hsa-gen.c
@@ -69,9 +69,10 @@ along with GCC; see the file COPYING3.  If not see
   do \
   { \
     hsa_fail_cfun (); \
-    if (warning_at (EXPR_LOCATION (hsa_cfun->m_decl), OPT_Whsa, \
+    diagnostic_group d; \
+    if (d.warning_at (EXPR_LOCATION (hsa_cfun->m_decl), OPT_Whsa,	\
 		    HSA_SORRY_MSG)) \
-      inform (location, message, __VA_ARGS__); \
+      d.inform (location, message, __VA_ARGS__); \
   } \
   while (false)
 
@@ -81,9 +82,10 @@ along with GCC; see the file COPYING3.  If not see
   do \
   { \
     hsa_fail_cfun (); \
-    if (warning_at (EXPR_LOCATION (hsa_cfun->m_decl), OPT_Whsa, \
+    diagnostic_group d; \
+    if (d.warning_at (EXPR_LOCATION (hsa_cfun->m_decl), OPT_Whsa, \
 		    HSA_SORRY_MSG)) \
-      inform (location, message); \
+      d.inform (location, message); \
   } \
   while (false)
 
diff --git a/gcc/ipa-devirt.c b/gcc/ipa-devirt.c
index e99d8cc..677a875 100644
--- a/gcc/ipa-devirt.c
+++ b/gcc/ipa-devirt.c
@@ -749,14 +749,16 @@ compare_virtual_tables (varpool_node *prevailing, varpool_node *vtable)
 	  prevailing = vtable;
 	  vtable = tmp;
 	}
-      if (warning_at (DECL_SOURCE_LOCATION
-			(TYPE_NAME (DECL_CONTEXT (vtable->decl))),
-		      OPT_Wodr,
-		      "virtual table of type %qD violates one definition rule",
-		      DECL_CONTEXT (vtable->decl)))
-	inform (DECL_SOURCE_LOCATION (prevailing->decl),
-		"variable of same assembler name as the virtual table is "
-		"defined in another translation unit");
+      diagnostic_group d;
+      if (d.warning_at (DECL_SOURCE_LOCATION
+			  (TYPE_NAME (DECL_CONTEXT (vtable->decl))),
+			OPT_Wodr,
+			"virtual table of type %qD violates one definition"
+			" rule",
+			DECL_CONTEXT (vtable->decl)))
+	d.inform (DECL_SOURCE_LOCATION (prevailing->decl),
+		  "variable of same assembler name as the virtual table is "
+		  "defined in another translation unit");
       return;
     }
   if (!prevailing->definition || !vtable->definition)
@@ -790,22 +792,25 @@ compare_virtual_tables (varpool_node *prevailing, varpool_node *vtable)
 	             && TREE_CODE (ref1->referred->decl) == FUNCTION_DECL))
 	     && TREE_CODE (ref2->referred->decl) != FUNCTION_DECL)
 	{
-	  if (!class_type->rtti_broken
-	      && warning_at (DECL_SOURCE_LOCATION
-			      (TYPE_NAME (DECL_CONTEXT (vtable->decl))),
-			     OPT_Wodr,
-			     "virtual table of type %qD contains RTTI "
-			     "information",
-			     DECL_CONTEXT (vtable->decl)))
+	  if (!class_type->rtti_broken)
 	    {
-	      inform (DECL_SOURCE_LOCATION
-			(TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
-		      "but is prevailed by one without from other translation "
-		      "unit");
-	      inform (DECL_SOURCE_LOCATION
-			(TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
-		      "RTTI will not work on this type");
-	      class_type->rtti_broken = true;
+	      diagnostic_group d;
+	      if (d.warning_at (DECL_SOURCE_LOCATION
+				  (TYPE_NAME (DECL_CONTEXT (vtable->decl))),
+				OPT_Wodr,
+				"virtual table of type %qD contains RTTI "
+				"information",
+				DECL_CONTEXT (vtable->decl)))
+		{
+		  d.inform (DECL_SOURCE_LOCATION
+			      (TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
+			    "but is prevailed by one without from other"
+			    " translation unit");
+		  d.inform (DECL_SOURCE_LOCATION
+			      (TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
+			    "RTTI will not work on this type");
+		  class_type->rtti_broken = true;
+		}
 	    }
 	  n2++;
           end2 = !vtable->iterate_reference (n2, ref2);
@@ -831,17 +836,19 @@ compare_virtual_tables (varpool_node *prevailing, varpool_node *vtable)
 	  if (DECL_SIZE (prevailing->decl) != DECL_SIZE (vtable->decl))
 	    {
 	      class_type->odr_violated = true;
-	      if (warning_at (DECL_SOURCE_LOCATION
-				(TYPE_NAME (DECL_CONTEXT (vtable->decl))),
-			      OPT_Wodr,
-			      "virtual table of type %qD violates "
-			      "one definition rule  ",
-			      DECL_CONTEXT (vtable->decl)))
+	      diagnostic_group d;
+	      if (d.warning_at (DECL_SOURCE_LOCATION
+				  (TYPE_NAME (DECL_CONTEXT (vtable->decl))),
+				OPT_Wodr,
+				"virtual table of type %qD violates "
+				"one definition rule  ",
+				DECL_CONTEXT (vtable->decl)))
 		{
-		  inform (DECL_SOURCE_LOCATION
-			    (TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
-			  "the conflicting type defined in another translation "
-			  "unit has virtual table of different size");
+		  d.inform (DECL_SOURCE_LOCATION
+			      (TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
+			    "the conflicting type defined in another "
+			    "translation unit has virtual table of different"
+			    " size");
 		}
 	    }
 	  return;
@@ -859,17 +866,18 @@ compare_virtual_tables (varpool_node *prevailing, varpool_node *vtable)
 	  if (TREE_CODE (ref1->referred->decl) != FUNCTION_DECL
 	      && TREE_CODE (ref2->referred->decl) != FUNCTION_DECL)
 	    {
-	      if (warning_at (DECL_SOURCE_LOCATION
-				(TYPE_NAME (DECL_CONTEXT (vtable->decl))),
-			      OPT_Wodr,
-			      "virtual table of type %qD violates "
-			      "one definition rule  ",
-			      DECL_CONTEXT (vtable->decl)))
+	      diagnostic_group d;
+	      if (d.warning_at (DECL_SOURCE_LOCATION
+				  (TYPE_NAME (DECL_CONTEXT (vtable->decl))),
+				OPT_Wodr,
+				"virtual table of type %qD violates "
+				"one definition rule  ",
+				DECL_CONTEXT (vtable->decl)))
 		{
-		  inform (DECL_SOURCE_LOCATION
-			    (TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
-			  "the conflicting type defined in another translation "
-			  "unit with different RTTI information");
+		  d.inform (DECL_SOURCE_LOCATION
+			      (TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
+			    "the conflicting type defined in another "
+			    "translation unit with different RTTI information");
 		}
 	      return;
 	    }
@@ -900,30 +908,32 @@ compare_virtual_tables (varpool_node *prevailing, varpool_node *vtable)
 	      vtable = tmp;
 	      ref1 = ref2;
 	    }
-	  if (warning_at (DECL_SOURCE_LOCATION
+	  diagnostic_group d;
+	  if (d.warning_at (DECL_SOURCE_LOCATION
 			    (TYPE_NAME (DECL_CONTEXT (vtable->decl))),
-			  OPT_Wodr,
-			  "virtual table of type %qD violates "
-			  "one definition rule",
-			  DECL_CONTEXT (vtable->decl)))
+			    OPT_Wodr,
+			    "virtual table of type %qD violates "
+			    "one definition rule",
+			    DECL_CONTEXT (vtable->decl)))
 	    {
 	      if (TREE_CODE (ref1->referring->decl) == FUNCTION_DECL)
 		{
-		  inform (DECL_SOURCE_LOCATION
-			   (TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
-			  "the conflicting type defined in another translation "
-			  "unit");
-		  inform (DECL_SOURCE_LOCATION
+		  d.inform (DECL_SOURCE_LOCATION
+			    (TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
+			    "the conflicting type defined in another "
+			    "translation unit");
+		  d.inform (DECL_SOURCE_LOCATION
 			    (TYPE_NAME (DECL_CONTEXT (ref1->referring->decl))),
-			  "contains additional virtual method %qD",
-			  ref1->referred->decl);
+			    "contains additional virtual method %qD",
+			    ref1->referred->decl);
 		}
 	      else
 		{
-		  inform (DECL_SOURCE_LOCATION
-			   (TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
-			  "the conflicting type defined in another translation "
-			  "unit has virtual table with more entries");
+		  d.inform (DECL_SOURCE_LOCATION
+			    (TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
+			    "the conflicting type defined in another "
+			    "translation unit has virtual table with more "
+			    "entries");
 		}
 	    }
 	  return;
@@ -931,34 +941,35 @@ compare_virtual_tables (varpool_node *prevailing, varpool_node *vtable)
 
       /* And in the last case we have either mistmatch in between two virtual
 	 methods or two virtual table pointers.  */
-      if (warning_at (DECL_SOURCE_LOCATION
+      diagnostic_group d;
+      if (d.warning_at (DECL_SOURCE_LOCATION
 			(TYPE_NAME (DECL_CONTEXT (vtable->decl))), OPT_Wodr,
-		      "virtual table of type %qD violates "
-		      "one definition rule  ",
-		      DECL_CONTEXT (vtable->decl)))
+			"virtual table of type %qD violates "
+			"one definition rule  ",
+			DECL_CONTEXT (vtable->decl)))
 	{
 	  if (TREE_CODE (ref1->referred->decl) == FUNCTION_DECL)
 	    {
-	      inform (DECL_SOURCE_LOCATION
+	      d.inform (DECL_SOURCE_LOCATION
 			(TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
-		      "the conflicting type defined in another translation "
-		      "unit");
+			"the conflicting type defined in another translation "
+			"unit");
 	      gcc_assert (TREE_CODE (ref2->referred->decl)
 			  == FUNCTION_DECL);
-	      inform (DECL_SOURCE_LOCATION
-			 (ref1->referred->ultimate_alias_target ()->decl),
-		      "virtual method %qD",
-		      ref1->referred->ultimate_alias_target ()->decl);
-	      inform (DECL_SOURCE_LOCATION
-			 (ref2->referred->ultimate_alias_target ()->decl),
-		      "ought to match virtual method %qD but does not",
-		      ref2->referred->ultimate_alias_target ()->decl);
+	      d.inform (DECL_SOURCE_LOCATION
+			(ref1->referred->ultimate_alias_target ()->decl),
+			"virtual method %qD",
+			ref1->referred->ultimate_alias_target ()->decl);
+	      d.inform (DECL_SOURCE_LOCATION
+			(ref2->referred->ultimate_alias_target ()->decl),
+			"ought to match virtual method %qD but does not",
+			ref2->referred->ultimate_alias_target ()->decl);
 	    }
 	  else
-	    inform (DECL_SOURCE_LOCATION
+	    d.inform (DECL_SOURCE_LOCATION
 		      (TYPE_NAME (DECL_CONTEXT (prevailing->decl))),
-		    "the conflicting type defined in another translation "
-		    "unit has virtual table with different contents");
+		      "the conflicting type defined in another translation "
+		      "unit has virtual table with different contents");
 	  return;
 	}
     }
@@ -986,9 +997,10 @@ warn_odr (tree t1, tree t2, tree st1, tree st2,
   if (lto_location_cache::current_cache)
     lto_location_cache::current_cache->apply_location_cache ();
 
-  if (!warning_at (DECL_SOURCE_LOCATION (TYPE_NAME (t1)), OPT_Wodr,
-		   "type %qT violates the C++ One Definition Rule",
-		   t1))
+  diagnostic_group d;
+  if (!d.warning_at (DECL_SOURCE_LOCATION (TYPE_NAME (t1)), OPT_Wodr,
+		     "type %qT violates the C++ One Definition Rule",
+		     t1))
     return;
   if (!st1 && !st2)
     ;
@@ -997,31 +1009,33 @@ warn_odr (tree t1, tree t2, tree st1, tree st2,
      elements.  */
   else if (!st1 || TREE_CODE (st1) == FIELD_DECL)
     {
-      inform (DECL_SOURCE_LOCATION (decl2),
-	      "a different type is defined in another translation unit");
+      d.inform (DECL_SOURCE_LOCATION (decl2),
+		"a different type is defined in another translation unit");
       if (!st1)
 	{
 	  st1 = st2;
 	  st2 = NULL;
 	}
-      inform (DECL_SOURCE_LOCATION (st1),
-	      "the first difference of corresponding definitions is field %qD",
-	      st1);
+      d.inform (DECL_SOURCE_LOCATION (st1),
+		"the first difference of corresponding definitions is field"
+		" %qD",
+		st1);
       if (st2)
         decl2 = st2;
     }
   else if (TREE_CODE (st1) == FUNCTION_DECL)
     {
-      inform (DECL_SOURCE_LOCATION (decl2),
-	      "a different type is defined in another translation unit");
-      inform (DECL_SOURCE_LOCATION (st1),
-	      "the first difference of corresponding definitions is method %qD",
-	      st1);
+      d.inform (DECL_SOURCE_LOCATION (decl2),
+		"a different type is defined in another translation unit");
+      d.inform (DECL_SOURCE_LOCATION (st1),
+		"the first difference of corresponding definitions is method"
+		" %qD",
+		st1);
       decl2 = st2;
     }
   else
     return;
-  inform (DECL_SOURCE_LOCATION (decl2), reason);
+  d.inform (DECL_SOURCE_LOCATION (decl2), reason);
 
   if (warned)
     *warned = true;
diff --git a/gcc/multiple_target.c b/gcc/multiple_target.c
index a1fe09a..0c28fea 100644
--- a/gcc/multiple_target.c
+++ b/gcc/multiple_target.c
@@ -347,8 +347,9 @@ expand_target_clones (struct cgraph_node *node, bool definition)
   if (node->definition
       && !tree_versionable_function_p (node->decl))
     {
-      error_at (DECL_SOURCE_LOCATION (node->decl),
-		"clones for %<target_clones%> attribute cannot be created");
+      diagnostic_group d;
+      d.error_at (DECL_SOURCE_LOCATION (node->decl),
+		  "clones for %<target_clones%> attribute cannot be created");
       const char *reason = NULL;
       if (lookup_attribute ("noclone", DECL_ATTRIBUTES (node->decl)))
 	reason = G_("function %q+F can never be copied "
@@ -356,7 +357,7 @@ expand_target_clones (struct cgraph_node *node, bool definition)
       else
 	reason = copy_forbidden (DECL_STRUCT_FUNCTION (node->decl));
       if (reason)
-	inform (DECL_SOURCE_LOCATION (node->decl), reason, node->decl);
+	d.inform (DECL_SOURCE_LOCATION (node->decl), reason, node->decl);
       return false;
     }
 
diff --git a/gcc/opts-common.c b/gcc/opts-common.c
index 1135644..0d794b4 100644
--- a/gcc/opts-common.c
+++ b/gcc/opts-common.c
@@ -1268,10 +1268,11 @@ cmdline_handle_error (location_t loc, const struct cl_option *option,
       unsigned int i;
       char *s;
 
+      diagnostic_group d;
       if (e->unknown_error)
-	error_at (loc, e->unknown_error, arg);
+	d.error_at (loc, e->unknown_error, arg);
       else
-	error_at (loc, "unrecognized argument in option %qs", opt);
+	d.error_at (loc, "unrecognized argument in option %qs", opt);
 
       auto_vec <const char *> candidates;
       for (i = 0; e->values[i].arg != NULL; i++)
@@ -1282,10 +1283,10 @@ cmdline_handle_error (location_t loc, const struct cl_option *option,
 	}
       const char *hint = candidates_list_and_hint (arg, s, candidates);
       if (hint)
-	inform (loc, "valid arguments to %qs are: %s; did you mean %qs?",
+	d.inform (loc, "valid arguments to %qs are: %s; did you mean %qs?",
 		option->opt_text, s, hint);
       else
-	inform (loc, "valid arguments to %qs are: %s", option->opt_text, s);
+	d.inform (loc, "valid arguments to %qs are: %s", option->opt_text, s);
       XDELETEVEC (s);
 
       return true;
diff --git a/gcc/reginfo.c b/gcc/reginfo.c
index 1f36d14..e111c51 100644
--- a/gcc/reginfo.c
+++ b/gcc/reginfo.c
@@ -782,11 +782,13 @@ globalize_reg (tree decl, int i)
 
   if (global_regs[i])
     {
-      warning_at (loc, 0, 
-		  "register of %qD used for multiple global register variables",
-		  decl);
-      inform (DECL_SOURCE_LOCATION (global_regs_decl[i]),
-	      "conflicts with %qD", global_regs_decl[i]); 
+      diagnostic_group d;
+      d.warning_at (loc, 0,
+		    "register of %qD used for multiple global register "
+		    "variables",
+		    decl);
+      d.inform (DECL_SOURCE_LOCATION (global_regs_decl[i]),
+		"conflicts with %qD", global_regs_decl[i]);
       return;
     }
 
diff --git a/gcc/substring-locations.c b/gcc/substring-locations.c
index 2d7f0c1..01ca02d 100644
--- a/gcc/substring-locations.c
+++ b/gcc/substring-locations.c
@@ -138,6 +138,7 @@ format_warning_n_va (const substring_loc &fmt_loc,
 	}
     }
 
+  diagnostic_group d;
   rich_location richloc (line_table, primary_loc);
 
   if (param_loc != UNKNOWN_LOCATION)
@@ -167,6 +168,7 @@ format_warning_n_va (const substring_loc &fmt_loc,
     diagnostic_set_info (&diagnostic, singular_gmsgid, ap, &richloc,
 			 DK_WARNING);
   diagnostic.option_index = opt;
+  diagnostic.group = &d;
   bool warned = diagnostic_report_diagnostic (global_dc, &diagnostic);
 
   if (!err && fmt_substring_loc && !substring_within_range)
@@ -177,8 +179,8 @@ format_warning_n_va (const substring_loc &fmt_loc,
 	if (corrected_substring)
 	  substring_richloc.add_fixit_replace (fmt_substring_range,
 					       corrected_substring);
-	inform (&substring_richloc,
-		"format string is defined here");
+	d.inform (&substring_richloc,
+		  "format string is defined here");
       }
 
   return warned;
diff --git a/gcc/tree-inline.c b/gcc/tree-inline.c
index 6a16ce5..e316af1 100644
--- a/gcc/tree-inline.c
+++ b/gcc/tree-inline.c
@@ -4416,14 +4416,15 @@ expand_call_inline (basic_block bb, gimple *stmt, copy_body_data *id)
 	       /* Avoid warnings during early inline pass. */
 	       && symtab->global_info_ready)
 	{
-	  if (warning (OPT_Winline, "inlining failed in call to %q+F: %s",
-		       fn, _(cgraph_inline_failed_string (reason))))
+	  diagnostic_group d;
+	  if (d.warning (OPT_Winline, "inlining failed in call to %q+F: %s",
+			 fn, _(cgraph_inline_failed_string (reason))))
 	    {
 	      if (gimple_location (stmt) != UNKNOWN_LOCATION)
-		inform (gimple_location (stmt), "called from here");
+		d.inform (gimple_location (stmt), "called from here");
 	      else if (DECL_SOURCE_LOCATION (cfun->decl) != UNKNOWN_LOCATION)
-		inform (DECL_SOURCE_LOCATION (cfun->decl),
-                       "called from this function");
+		d.inform (DECL_SOURCE_LOCATION (cfun->decl),
+			  "called from this function");
 	    }
 	}
       goto egress;
diff --git a/gcc/tree-ssa-ccp.c b/gcc/tree-ssa-ccp.c
index 63c9531..e29719d 100644
--- a/gcc/tree-ssa-ccp.c
+++ b/gcc/tree-ssa-ccp.c
@@ -3454,18 +3454,19 @@ pass_post_ipa_warn::execute (function *fun)
 			continue;
 
 		      location_t loc = gimple_location (stmt);
-		      if (warning_at (loc, OPT_Wnonnull,
-				      "%Gargument %u null where non-null "
-				      "expected", stmt, i + 1))
+		      diagnostic_group d;
+		      if (d.warning_at (loc, OPT_Wnonnull,
+					"%Gargument %u null where non-null "
+					"expected", stmt, i + 1))
 			{
 			  tree fndecl = gimple_call_fndecl (stmt);
 			  if (fndecl && DECL_IS_BUILTIN (fndecl))
-			    inform (loc, "in a call to built-in function %qD",
-				    fndecl);
+			    d.inform (loc, "in a call to built-in function %qD",
+				      fndecl);
 			  else if (fndecl)
-			    inform (DECL_SOURCE_LOCATION (fndecl),
-				    "in a call to function %qD declared here",
-				    fndecl);
+			    d.inform (DECL_SOURCE_LOCATION (fndecl),
+				      "in a call to function %qD declared here",
+				      fndecl);
 
 			}
 		    }
diff --git a/gcc/tree-ssa-loop-niter.c b/gcc/tree-ssa-loop-niter.c
index fbdf838..3b39f9b 100644
--- a/gcc/tree-ssa-loop-niter.c
+++ b/gcc/tree-ssa-loop-niter.c
@@ -3231,9 +3231,10 @@ do_warn_aggressive_loop_optimizations (struct loop *loop,
   char buf[WIDE_INT_PRINT_BUFFER_SIZE];
   print_dec (i_bound, buf, TYPE_UNSIGNED (TREE_TYPE (loop->nb_iterations))
 	     ? UNSIGNED : SIGNED);
-  if (warning_at (gimple_location (stmt), OPT_Waggressive_loop_optimizations,
-		  "iteration %s invokes undefined behavior", buf))
-    inform (gimple_location (estmt), "within this loop");
+  diagnostic_group d;
+  if (d.warning_at (gimple_location (stmt), OPT_Waggressive_loop_optimizations,
+		    "iteration %s invokes undefined behavior", buf))
+    d.inform (gimple_location (estmt), "within this loop");
   loop->warned_aggressive_loop_optimizations = true;
 }
 
diff --git a/gcc/tree-ssa-uninit.c b/gcc/tree-ssa-uninit.c
index 8ccbc85..4ba9536 100644
--- a/gcc/tree-ssa-uninit.c
+++ b/gcc/tree-ssa-uninit.c
@@ -178,7 +178,8 @@ warn_uninit (enum opt_code wc, tree t, tree expr, tree var,
   cfun_loc = DECL_SOURCE_LOCATION (cfun->decl);
   xloc = expand_location (location);
   floc = expand_location (cfun_loc);
-  if (warning_at (location, wc, gmsgid, expr))
+  diagnostic_group d;
+  if (d.warning_at (location, wc, gmsgid, expr))
     {
       TREE_NO_WARNING (expr) = 1;
 
@@ -188,7 +189,7 @@ warn_uninit (enum opt_code wc, tree t, tree expr, tree var,
 	  || linemap_location_before_p (line_table, location, cfun_loc)
 	  || linemap_location_before_p (line_table, cfun->function_end_locus,
 					location))
-	inform (DECL_SOURCE_LOCATION (var), "%qD was declared here", var);
+	d.inform (DECL_SOURCE_LOCATION (var), "%qD was declared here", var);
     }
 }
 
diff --git a/gcc/tree.c b/gcc/tree.c
index 0ec74af..20af74c 100644
--- a/gcc/tree.c
+++ b/gcc/tree.c
@@ -12613,14 +12613,15 @@ warn_deprecated_use (tree node, tree attr)
   bool w = false;
   if (DECL_P (node))
     {
+      diagnostic_group d;
       if (msg)
-	w = warning (OPT_Wdeprecated_declarations,
-		     "%qD is deprecated: %s", node, (const char *) msg);
+	w = d.warning (OPT_Wdeprecated_declarations,
+		       "%qD is deprecated: %s", node, (const char *) msg);
       else
-	w = warning (OPT_Wdeprecated_declarations,
-		     "%qD is deprecated", node);
+	w = d.warning (OPT_Wdeprecated_declarations,
+		       "%qD is deprecated", node);
       if (w)
-	inform (DECL_SOURCE_LOCATION (node), "declared here");
+	d.inform (DECL_SOURCE_LOCATION (node), "declared here");
     }
   else if (TYPE_P (node))
     {
@@ -12636,27 +12637,28 @@ warn_deprecated_use (tree node, tree attr)
 	    what = DECL_NAME (TYPE_NAME (node));
 	}
 
+      diagnostic_group d;
       if (what)
 	{
 	  if (msg)
-	    w = warning (OPT_Wdeprecated_declarations,
-			 "%qE is deprecated: %s", what, (const char *) msg);
+	    w = d.warning (OPT_Wdeprecated_declarations,
+			   "%qE is deprecated: %s", what, (const char *) msg);
 	  else
-	    w = warning (OPT_Wdeprecated_declarations,
-			 "%qE is deprecated", what);
+	    w = d.warning (OPT_Wdeprecated_declarations,
+			   "%qE is deprecated", what);
 	}
       else
 	{
 	  if (msg)
-	    w = warning (OPT_Wdeprecated_declarations,
-			 "type is deprecated: %s", (const char *) msg);
+	    w = d.warning (OPT_Wdeprecated_declarations,
+			   "type is deprecated: %s", (const char *) msg);
 	  else
-	    w = warning (OPT_Wdeprecated_declarations,
-			 "type is deprecated");
+	    w = d.warning (OPT_Wdeprecated_declarations,
+			   "type is deprecated");
 	}
 
       if (w && decl)
-	inform (DECL_SOURCE_LOCATION (decl), "declared here");
+	d.inform (DECL_SOURCE_LOCATION (decl), "declared here");
     }
 
   return w;
-- 
1.8.5.3

